

;LAUTSTRKE 60
Global FileName$,MUTEX
Global READY = 0

Procedure MCI(command.s) 
  result=mciSendString_(command,@buffer$,256,0) 
  ProcedureReturn result 
EndProcedure
Procedure RecordIt(d)
  
  WAV$ = GetPathPart(FileName$) + "scene.wav" 
  MCI("open new type waveaudio alias aua") 
  MCI("set aua time format ms bitspersample 16 channels 2 samplespersec 44100 BYTESPERSEC 176400 ALIGNMENT 4") 
  LockMutex(MUTEX) 
  READY = 1
  UnlockMutex(MUTEX)
  MCI("record aua from 0 to "+Str(d)+" wait") 
  MCI("save aua " + WAV$) 
  MCI("close aua") 
  Debug "ende aufnahme"
EndProcedure 
;RecordIt(9000)


MUTEX = CreateMutex()

If InitSound() = 0
  MessageRequester("Error", "Sound system is not available",  0)
  End
EndIf


FileName$ = OpenFileRequester("Choose a .txt file", "", "Sound Liste|*.txt",0)
PATH$= GetPathPart(FileName$) 

OpenFile(1,FileName$)
NUM_FRAMES = Val(ReadString(1))
Repeat
  NUMBER +1
  LINE$ = ReadString(1)
  FRAME = Val(Trim(StringField(LINE$,1, ";")))
  FILE$ = Trim(StringField(LINE$,2, ";"))
  PAN   = Val(Trim(StringField(LINE$,3, ";")))
  If FILE$ <> ""
    If LoadSound(FRAME, PATH$ + FILE$) = 0
      MessageRequester("","Cannot load sound: " + PATH$ + FILE$)
    Else
      Debug PATH$ + FILE$ + " loaded"
    EndIf  
  EndIf  
Until Eof(1)  
CloseFile(1)

DURATION = NUM_FRAMES * 25

NUMBER = 0
OpenFile(1,FileName$)
NUM_FRAMES = Val(ReadString(1))
LINE$ = ReadString(1)
;Debug LINE$

Delay(2000)
TH = CreateThread(@RecordIt(),DURATION)

Repeat
  LockMutex(MUTEX) 
  VAL = READY
UnlockMutex(MUTEX) 
Until VAL = 1
start = timeGetTime_()

Repeat
  NUMBER +1
  FRAME = Val(Trim(StringField(LINE$,1, ";")))
  FILE$ = Trim(StringField(LINE$,2, ";"))
  PAN   = Val(Trim(StringField(LINE$,3, ";")))
  If PAN < -100:PAN = -100:EndIf
  If PAN >  100:PAN =  100:EndIf
  
  ;Debug timeGetTime_()
  Frame_POS.f = (timeGetTime_() - start) * 25.0 / 1000.0 
  ;Debug LINE$  
 ; Debug StrF(Frame_POS)  + "   " +Str(FRAME)
 If Frame_POS >= FRAME;NUMBER
   
    If eof = 0
      LINE$ = ReadString(1)  
    Else
      LINE$ = ""
    EndIf

    If IsSound(FRAME) And FILE$ <> ""
      
      Debug "PLAY " +Str(FRAME)
      SoundPan(FRAME, PAN)
      ;SoundFrequency(FRAME, Random(9999)+4444)
      SoundVolume(FRAME, 100)
      PlaySound(FRAME);,#PB_Sound_MultiChannel)
    Else
      MessageRequester("","error")
    EndIf
  EndIf
  
  If Eof(1)
    eof = 1
  EndIf  
Until eof And LINE$=""

Debug "end: " +Str(timeGetTime_() - start)
CloseFile(1)
Delay(2000)
WaitThread(TH)
; IDE Options = PureBasic 5.00 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableThread
; EnableXP
; Executable = sound_merger.exe